#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "asm-list.h"

//ASM for TA/MACH-I 
//Copyright (C) 2010 R.Suzuki All Rights Reserved. 

unsigned int label_addr[26]={
0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,
};
int parse_line(char *buf);
int parse_opcode(char *opcode);
int parse_dest (char *dest,int inst);
void check_label(char *buf);
int back_label(char *source);
unsigned int jmp_label(char *dest,int dest_no);

int main(int argc,char *argv[]){
	FILE *fr;
    FILE *fw;
    char buf[256];
    int inst;
    int i;
    int count=0;
    if(!((argc==3)||(argc==2))){
    	printf("Usage: tasm [asm] [output]\n");
        return (-1);
    }
    
    if(argc==2){
       	if((fw=fopen("a.coe","w"))==NULL){
    		printf("Error: Unable to open file");
    		return (-1);
    	}
    }
    	
    if((fr=fopen(argv[1],"r"))==NULL){
    	printf("Error: Unable to open file");
        return (-1);
    }
    
    if(argc==3){
    	if((fw=fopen(argv[2],"w"))==NULL){
    		printf("Error: Unable to open file");
     		return (-1);
    	}
    }
    fprintf(fw,"memory_initialization_radix=16;\n");
    fprintf(fw,"\nmemory_initialization_vector=\n");

	while(fgets(buf,255,fr)!=NULL)check_label(buf);
    fseek(fr,0,SEEK_SET);
   
    while(fgets(buf,255,fr)!=NULL){
		if((buf[0]!='#')&&(buf[0]!=';')&&(buf[0]!='@')){
        	if(buf[0]=='.'){
            	for(i=0;i<256;i++){
                	if(buf[i]=='\n')buf[i]='\0';
                }
        		fprintf(fw,"%s,\n",&buf[1]);
                count++;
                printf("const:%s\n",&buf[1]);
        	}
        	else if(buf[0]=='\n'){
            	fprintf(fw,"\n");
                printf("\n");
            }
            else{
        		for(i=0;i<256;i++){
        			buf[i]=tolower(buf[i]);
       			}	
        		inst=parse_line(buf);
                count++;
				fprintf(fw,"%x,\n",inst);
        	}
        }
    }
    printf("total:%dwords = %dbytes\n",count,count*2);
    fprintf(fw,"6000;\n");
    fclose(fr);
    fclose(fw);
}

int parse_line(char *buf){
	char *ptr;
    char opcode[16];
	char dest[16];
	char source[16];
    int inst;
    
	ptr=strtok(buf," ,");
	if(ptr==NULL) return(-1);
	strcpy(opcode,ptr);
	inst=parse_opcode(opcode);
    
    ptr=strtok(NULL," ,");
	if(ptr!=NULL)strcpy(dest,ptr);
    inst=parse_dest(dest,inst);
    
    ptr=strtok(NULL," ,");
	if(ptr!=NULL)strcpy(source,ptr);
    inst=parse_source(source,inst);
    
	return (inst);
}

int parse_opcode(char *opcode){
	int cnt=0;
    printf("%s\n",opcode);
    while((strcmp(opcode,inst[cnt])!=0)&&(cnt<255)){
    	cnt++;
    }
    if(cnt==255)return (-1);
    return (inst_no[cnt]);
}

int parse_dest (char *dest,int inst){
	int dest_no=0;
	
    if(*dest=='r')dest++;
    
    if((*dest=='0')&&(*(dest+1)=='x')){
    	dest+=2;
        dest_no=(int)strtol(dest,NULL,16);
    }
    
    else dest_no=(int)strtol(dest,NULL,10);
	
    if((inst==-2)&&(strcmp(dest,"x\n")==0))return (0x4000);
    else if(inst==-2) return(jmp_label(dest,dest_no));//0x5000
    
    if((inst==-3)&&(*dest=='-'))return(0x6000+abs(dest_no));
    else if(inst==-3) return (0x7000+abs(dest_no));
    
    if(inst==0)return 0;
    if((inst>=0x1000)&&(inst<=0x1f00))return(((dest_no)<<4)+inst);
   
    if(inst==0x2000)return(((dest_no)<<4)+inst);
    
   	if(inst==0x3000)return(((dest_no)<<4)+inst);
    
    //BZ
    if(inst==0x4100){
    	if(strcmp(dest,"x\n")==0)return(0x4100);
    	else if(*dest=='-')return (0x4400+abs(dest_no));
		else return (0x4700+abs(dest_no));
    }
    
    //BC
    if(inst==0x4200){
    	if(strcmp(dest,"x\n")==0)return(0x4200);
    	else if(*dest=='-')return (0x4500+abs(dest_no));
        else return (0x4800+abs(dest_no));
    }
    
    //BN
    if(inst==0x4300){
    	if(strcmp(dest,"x\n")==0)return(0x4300);
    	else if(*dest=='-')return (0x4600+abs(dest_no));
        else return (0x4900+abs(dest_no));
    }
    
    if(inst==0x8000)return (0x8000+(dest_no<<8));
    if(inst==0x9000)return (0x9000+(dest_no<<8));
    
    return inst;
}

int parse_source(char *source,int inst){
	int source_no=0;
	if(*source=='r')source++;
    if((*source=='0')&&(*(source+1)=='x')){
    	source+=2;
        source_no=(int)strtol(source,NULL,16);
    }
    else if(*source=='&')source_no=back_label(source);
    else source_no=(int)strtol(source,NULL,10);
	if(inst==0)return 0;
    if((inst>=0x1000)&&(inst<=0x1ff0))return(source_no+inst);
    
    if(inst==0x2800)return(source_no+inst);
    
   	if(inst==0x3800)return(source_no+inst);
    
    if((inst&0xf000)==0x8000)return (inst+abs(source_no));
    if((inst&0xf000)==0x9000)return (inst+abs(source_no));
    
    return (inst);
}
unsigned int jmp_label(char *dest,int dest_no){
	int addr;
	if(*dest=='&'){
    	addr=toupper(*(dest+1));
        addr=addr-0x41;
        if(addr<0)return(0x5000);
        if(addr>25)return(0x5000);
        return(0x5000+label_addr[addr]);	
    }
    
    else{
    	return (abs(dest_no)+0x5000);
    }
}
void check_label(char *buf){
	int addr=0;
    static unsigned int cnt=0;
    if(*buf=='@'){
    	addr=toupper(*(buf+1));
        addr-=0x41;
        if(addr<0)return;
        if(addr>25)return;
    	label_addr[addr]=cnt;
    }
    else if((*buf!='#')&&(*buf!=';')&&(*buf!='\n')){
    	cnt++;
    }
	return;
}

int back_label(char *source){
	int addr=0;
	if(*(source+1)=='l'){
		addr=toupper(*(source+2));
        addr=addr-0x41;
        if(addr<0)return(0);
        if(addr>25)return(0);
        return(label_addr[addr]&0x00ff);
    }
    if(*(source+1)=='h'){
		addr=toupper(*(source+2));
        addr=addr-0x41;
        if(addr<0)return(0);
        if(addr>25)return(0);
        return((label_addr[addr]&0xff00)>>8);
    }
}
